'use strict';
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var execa_1 = __importDefault(require("execa"));
var fs_1 = __importDefault(require("fs"));
var inquirer_1 = __importDefault(require("inquirer"));
var ora_1 = __importDefault(require("ora"));
var path_1 = __importDefault(require("path"));
var node_banner_1 = __importDefault(require("node-banner"));
var logger = __importStar(require("../utils/logger"));
var helpers_1 = require("../utils/helpers");
// Setting path to the template files.
var templatePath = path_1.default.join(__dirname, '..', 'templates');
exports.default = (function (projectName, args) { return __awaiter(void 0, void 0, void 0, function () {
    var hasStrayArgs, isCurrentDir, frameworkOfChoice, cssDirPath, jsDirPath, template, pm, installCmd, deps, spinner, pkgJson, webpackConfig, msg;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, node_banner_1.default('Scaffold Static', 'scaffolding utility for vanilla-js')];
            case 1:
                _a.sent();
                console.log();
                hasStrayArgs = process.argv[4] && !process.argv[4].startsWith('-');
                // Do not accept multiple arguments for the project name
                if (hasStrayArgs) {
                    logger.error(' Please provide only one argument as the project name');
                    process.exit(1);
                }
                isCurrentDir = projectName === '.';
                if (isCurrentDir && fs_1.default.readdirSync('.').length) {
                    logger.error(" The current directory isn't empty");
                    process.exit(1);
                }
                if (!isCurrentDir && fs_1.default.existsSync(projectName)) {
                    logger.error(" " + projectName + " already exists in path");
                    process.exit(1);
                }
                return [4 /*yield*/, inquirer_1.default.prompt([
                        {
                            name: 'frameworkOfChoice',
                            type: 'list',
                            message: 'Please choose the CSS framework of your choice',
                            choices: [
                                'Bootstrap-3',
                                'Bootstrap-4',
                                'Materialize',
                                'Foundation',
                                'Semantic-UI',
                                'Bulma',
                                'None',
                            ],
                        },
                    ])];
            case 2:
                frameworkOfChoice = (_a.sent()).frameworkOfChoice;
                // Create the project directory
                !isCurrentDir && fs_1.default.mkdirSync(projectName);
                cssDirPath = path_1.default.join(projectName, 'css');
                jsDirPath = path_1.default.join(projectName, 'js');
                fs_1.default.mkdirSync(cssDirPath);
                fs_1.default.mkdirSync(jsDirPath);
                fs_1.default.writeFileSync(path_1.default.join(cssDirPath, 'style.css'), '/* Write your rulesets here! */');
                fs_1.default.writeFileSync(path_1.default.join(jsDirPath, 'main.js'), "require('../css/style.css');");
                template = fs_1.default.readFileSync(path_1.default.join(templatePath, frameworkOfChoice.toLowerCase(), 'index.html'), 'utf-8');
                fs_1.default.writeFileSync(path_1.default.join(projectName, 'index.html'), template);
                pm = helpers_1.getPackageManager(args.useNpm);
                installCmd = pm === 'yarn' ? 'add' : 'install';
                deps = [
                    'webpack',
                    'webpack-cli',
                    'webpack-dev-server',
                    'css-loader',
                    'style-loader',
                    'html-webpack-plugin',
                ];
                spinner = ora_1.default('Getting things ready').start();
                // Create package.json
                return [4 /*yield*/, execa_1.default(pm, ['init', '-y'], { cwd: projectName })];
            case 3:
                // Create package.json
                _a.sent();
                // Installing required dependencies
                spinner.text = 'Installing dependencies';
                return [4 /*yield*/, execa_1.default(pm, __spreadArrays([installCmd, '-D'], deps), { cwd: projectName })];
            case 4:
                _a.sent();
                pkgJson = JSON.parse(fs_1.default.readFileSync(path_1.default.join(projectName, 'package.json')).toString());
                // Add build and serve scripts
                pkgJson = __assign(__assign({}, pkgJson), { scripts: {
                        build: 'webpack',
                        serve: 'webpack serve',
                    } });
                if (!isCurrentDir) {
                    pkgJson.name = projectName;
                }
                fs_1.default.writeFileSync(path_1.default.join(projectName, 'package.json'), JSON.stringify(pkgJson, null, 2));
                webpackConfig = fs_1.default.readFileSync(path_1.default.join(templatePath, 'webpack.config.js'));
                fs_1.default.writeFileSync(path_1.default.join(projectName, 'webpack.config.js'), webpackConfig);
                // Show success spinner
                spinner.succeed("You're all set");
                // Instructions to the user
                console.log();
                logger.success('Now, type in:');
                msg = pm + " run serve";
                if (!isCurrentDir) {
                    msg = "cd " + projectName + " && " + msg;
                }
                logger.info(msg);
                return [2 /*return*/];
        }
    });
}); });
